import { AfterViewInit, ElementRef, OnInit, EventEmitter } from "@angular/core";
import { Subject } from "rxjs";
export declare class CanLoadDirective implements OnInit, AfterViewInit {
    private elementRef;
    throttlingTime: number;
    threshold: number;
    observer: IntersectionObserver | undefined;
    intersectionChanged$: Subject<any>;
    visible: EventEmitter<any>;
    constructor(elementRef: ElementRef);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    /**
     * Check the visibility of listening(Child) element
     * @param {HTMLElement} element element listening to changes in scroll
     * @returns {boolean} if element is visible to the given extend then true, else false
     * @author Athul Narayanan
     */
    isVisible(element: HTMLElement): Promise<unknown>;
    /**
     * Create intersection observer based on container element(usually the entire viewport)
     * @author Athul Narayanan
     */
    createObserver(): void;
    /**
     *
     * @returns an event saying that element is visble in the container
     * @author Athul Narayanan
     */
    startObserving(): void;
}
